// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: regulatormodule/regulatormodule.proto

package openfmb.regulatormodule;

/**
 * <pre>
 * Regulator control profile.  Instructs an end device (or an end device group) to perform a
 * specified action.
 * </pre>
 *
 * Protobuf type {@code regulatormodule.RegulatorControlProfile}
 */
public final class RegulatorControlProfile extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:regulatormodule.RegulatorControlProfile)
    RegulatorControlProfileOrBuilder {
private static final long serialVersionUID = 0L;
  // Use RegulatorControlProfile.newBuilder() to construct.
  private RegulatorControlProfile(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private RegulatorControlProfile() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new RegulatorControlProfile();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.regulatormodule.Regulatormodule.internal_static_regulatormodule_RegulatorControlProfile_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.regulatormodule.Regulatormodule.internal_static_regulatormodule_RegulatorControlProfile_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.regulatormodule.RegulatorControlProfile.class, openfmb.regulatormodule.RegulatorControlProfile.Builder.class);
  }

  public static final int CONTROLMESSAGEINFO_FIELD_NUMBER = 1;
  private openfmb.commonmodule.ControlMessageInfo controlMessageInfo_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the controlMessageInfo field is set.
   */
  @java.lang.Override
  public boolean hasControlMessageInfo() {
    return controlMessageInfo_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
   * @return The controlMessageInfo.
   */
  @java.lang.Override
  public openfmb.commonmodule.ControlMessageInfo getControlMessageInfo() {
    return controlMessageInfo_ == null ? openfmb.commonmodule.ControlMessageInfo.getDefaultInstance() : controlMessageInfo_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ControlMessageInfoOrBuilder getControlMessageInfoOrBuilder() {
    return controlMessageInfo_ == null ? openfmb.commonmodule.ControlMessageInfo.getDefaultInstance() : controlMessageInfo_;
  }

  public static final int REGULATORCONTROL_FIELD_NUMBER = 2;
  private openfmb.regulatormodule.RegulatorControl regulatorControl_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.regulatormodule.RegulatorControl regulatorControl = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the regulatorControl field is set.
   */
  @java.lang.Override
  public boolean hasRegulatorControl() {
    return regulatorControl_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.regulatormodule.RegulatorControl regulatorControl = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The regulatorControl.
   */
  @java.lang.Override
  public openfmb.regulatormodule.RegulatorControl getRegulatorControl() {
    return regulatorControl_ == null ? openfmb.regulatormodule.RegulatorControl.getDefaultInstance() : regulatorControl_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.regulatormodule.RegulatorControl regulatorControl = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.regulatormodule.RegulatorControlOrBuilder getRegulatorControlOrBuilder() {
    return regulatorControl_ == null ? openfmb.regulatormodule.RegulatorControl.getDefaultInstance() : regulatorControl_;
  }

  public static final int REGULATORSYSTEM_FIELD_NUMBER = 3;
  private openfmb.regulatormodule.RegulatorSystem regulatorSystem_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.regulatormodule.RegulatorSystem regulatorSystem = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the regulatorSystem field is set.
   */
  @java.lang.Override
  public boolean hasRegulatorSystem() {
    return regulatorSystem_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.regulatormodule.RegulatorSystem regulatorSystem = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The regulatorSystem.
   */
  @java.lang.Override
  public openfmb.regulatormodule.RegulatorSystem getRegulatorSystem() {
    return regulatorSystem_ == null ? openfmb.regulatormodule.RegulatorSystem.getDefaultInstance() : regulatorSystem_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.regulatormodule.RegulatorSystem regulatorSystem = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.regulatormodule.RegulatorSystemOrBuilder getRegulatorSystemOrBuilder() {
    return regulatorSystem_ == null ? openfmb.regulatormodule.RegulatorSystem.getDefaultInstance() : regulatorSystem_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (controlMessageInfo_ != null) {
      output.writeMessage(1, getControlMessageInfo());
    }
    if (regulatorControl_ != null) {
      output.writeMessage(2, getRegulatorControl());
    }
    if (regulatorSystem_ != null) {
      output.writeMessage(3, getRegulatorSystem());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (controlMessageInfo_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getControlMessageInfo());
    }
    if (regulatorControl_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getRegulatorControl());
    }
    if (regulatorSystem_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getRegulatorSystem());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.regulatormodule.RegulatorControlProfile)) {
      return super.equals(obj);
    }
    openfmb.regulatormodule.RegulatorControlProfile other = (openfmb.regulatormodule.RegulatorControlProfile) obj;

    if (hasControlMessageInfo() != other.hasControlMessageInfo()) return false;
    if (hasControlMessageInfo()) {
      if (!getControlMessageInfo()
          .equals(other.getControlMessageInfo())) return false;
    }
    if (hasRegulatorControl() != other.hasRegulatorControl()) return false;
    if (hasRegulatorControl()) {
      if (!getRegulatorControl()
          .equals(other.getRegulatorControl())) return false;
    }
    if (hasRegulatorSystem() != other.hasRegulatorSystem()) return false;
    if (hasRegulatorSystem()) {
      if (!getRegulatorSystem()
          .equals(other.getRegulatorSystem())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasControlMessageInfo()) {
      hash = (37 * hash) + CONTROLMESSAGEINFO_FIELD_NUMBER;
      hash = (53 * hash) + getControlMessageInfo().hashCode();
    }
    if (hasRegulatorControl()) {
      hash = (37 * hash) + REGULATORCONTROL_FIELD_NUMBER;
      hash = (53 * hash) + getRegulatorControl().hashCode();
    }
    if (hasRegulatorSystem()) {
      hash = (37 * hash) + REGULATORSYSTEM_FIELD_NUMBER;
      hash = (53 * hash) + getRegulatorSystem().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.regulatormodule.RegulatorControlProfile parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.regulatormodule.RegulatorControlProfile parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.regulatormodule.RegulatorControlProfile parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.regulatormodule.RegulatorControlProfile parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.regulatormodule.RegulatorControlProfile parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.regulatormodule.RegulatorControlProfile parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.regulatormodule.RegulatorControlProfile parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.regulatormodule.RegulatorControlProfile parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.regulatormodule.RegulatorControlProfile parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.regulatormodule.RegulatorControlProfile parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.regulatormodule.RegulatorControlProfile parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.regulatormodule.RegulatorControlProfile parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.regulatormodule.RegulatorControlProfile prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Regulator control profile.  Instructs an end device (or an end device group) to perform a
   * specified action.
   * </pre>
   *
   * Protobuf type {@code regulatormodule.RegulatorControlProfile}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:regulatormodule.RegulatorControlProfile)
      openfmb.regulatormodule.RegulatorControlProfileOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.regulatormodule.Regulatormodule.internal_static_regulatormodule_RegulatorControlProfile_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.regulatormodule.Regulatormodule.internal_static_regulatormodule_RegulatorControlProfile_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.regulatormodule.RegulatorControlProfile.class, openfmb.regulatormodule.RegulatorControlProfile.Builder.class);
    }

    // Construct using openfmb.regulatormodule.RegulatorControlProfile.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      controlMessageInfo_ = null;
      if (controlMessageInfoBuilder_ != null) {
        controlMessageInfoBuilder_.dispose();
        controlMessageInfoBuilder_ = null;
      }
      regulatorControl_ = null;
      if (regulatorControlBuilder_ != null) {
        regulatorControlBuilder_.dispose();
        regulatorControlBuilder_ = null;
      }
      regulatorSystem_ = null;
      if (regulatorSystemBuilder_ != null) {
        regulatorSystemBuilder_.dispose();
        regulatorSystemBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.regulatormodule.Regulatormodule.internal_static_regulatormodule_RegulatorControlProfile_descriptor;
    }

    @java.lang.Override
    public openfmb.regulatormodule.RegulatorControlProfile getDefaultInstanceForType() {
      return openfmb.regulatormodule.RegulatorControlProfile.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.regulatormodule.RegulatorControlProfile build() {
      openfmb.regulatormodule.RegulatorControlProfile result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.regulatormodule.RegulatorControlProfile buildPartial() {
      openfmb.regulatormodule.RegulatorControlProfile result = new openfmb.regulatormodule.RegulatorControlProfile(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.regulatormodule.RegulatorControlProfile result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.controlMessageInfo_ = controlMessageInfoBuilder_ == null
            ? controlMessageInfo_
            : controlMessageInfoBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.regulatorControl_ = regulatorControlBuilder_ == null
            ? regulatorControl_
            : regulatorControlBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.regulatorSystem_ = regulatorSystemBuilder_ == null
            ? regulatorSystem_
            : regulatorSystemBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.regulatormodule.RegulatorControlProfile) {
        return mergeFrom((openfmb.regulatormodule.RegulatorControlProfile)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.regulatormodule.RegulatorControlProfile other) {
      if (other == openfmb.regulatormodule.RegulatorControlProfile.getDefaultInstance()) return this;
      if (other.hasControlMessageInfo()) {
        mergeControlMessageInfo(other.getControlMessageInfo());
      }
      if (other.hasRegulatorControl()) {
        mergeRegulatorControl(other.getRegulatorControl());
      }
      if (other.hasRegulatorSystem()) {
        mergeRegulatorSystem(other.getRegulatorSystem());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getControlMessageInfoFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getRegulatorControlFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getRegulatorSystemFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.ControlMessageInfo controlMessageInfo_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ControlMessageInfo, openfmb.commonmodule.ControlMessageInfo.Builder, openfmb.commonmodule.ControlMessageInfoOrBuilder> controlMessageInfoBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the controlMessageInfo field is set.
     */
    public boolean hasControlMessageInfo() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     * @return The controlMessageInfo.
     */
    public openfmb.commonmodule.ControlMessageInfo getControlMessageInfo() {
      if (controlMessageInfoBuilder_ == null) {
        return controlMessageInfo_ == null ? openfmb.commonmodule.ControlMessageInfo.getDefaultInstance() : controlMessageInfo_;
      } else {
        return controlMessageInfoBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setControlMessageInfo(openfmb.commonmodule.ControlMessageInfo value) {
      if (controlMessageInfoBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        controlMessageInfo_ = value;
      } else {
        controlMessageInfoBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setControlMessageInfo(
        openfmb.commonmodule.ControlMessageInfo.Builder builderForValue) {
      if (controlMessageInfoBuilder_ == null) {
        controlMessageInfo_ = builderForValue.build();
      } else {
        controlMessageInfoBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeControlMessageInfo(openfmb.commonmodule.ControlMessageInfo value) {
      if (controlMessageInfoBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          controlMessageInfo_ != null &&
          controlMessageInfo_ != openfmb.commonmodule.ControlMessageInfo.getDefaultInstance()) {
          getControlMessageInfoBuilder().mergeFrom(value);
        } else {
          controlMessageInfo_ = value;
        }
      } else {
        controlMessageInfoBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearControlMessageInfo() {
      bitField0_ = (bitField0_ & ~0x00000001);
      controlMessageInfo_ = null;
      if (controlMessageInfoBuilder_ != null) {
        controlMessageInfoBuilder_.dispose();
        controlMessageInfoBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ControlMessageInfo.Builder getControlMessageInfoBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getControlMessageInfoFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ControlMessageInfoOrBuilder getControlMessageInfoOrBuilder() {
      if (controlMessageInfoBuilder_ != null) {
        return controlMessageInfoBuilder_.getMessageOrBuilder();
      } else {
        return controlMessageInfo_ == null ?
            openfmb.commonmodule.ControlMessageInfo.getDefaultInstance() : controlMessageInfo_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ControlMessageInfo, openfmb.commonmodule.ControlMessageInfo.Builder, openfmb.commonmodule.ControlMessageInfoOrBuilder> 
        getControlMessageInfoFieldBuilder() {
      if (controlMessageInfoBuilder_ == null) {
        controlMessageInfoBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ControlMessageInfo, openfmb.commonmodule.ControlMessageInfo.Builder, openfmb.commonmodule.ControlMessageInfoOrBuilder>(
                getControlMessageInfo(),
                getParentForChildren(),
                isClean());
        controlMessageInfo_ = null;
      }
      return controlMessageInfoBuilder_;
    }

    private openfmb.regulatormodule.RegulatorControl regulatorControl_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.regulatormodule.RegulatorControl, openfmb.regulatormodule.RegulatorControl.Builder, openfmb.regulatormodule.RegulatorControlOrBuilder> regulatorControlBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorControl regulatorControl = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the regulatorControl field is set.
     */
    public boolean hasRegulatorControl() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorControl regulatorControl = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The regulatorControl.
     */
    public openfmb.regulatormodule.RegulatorControl getRegulatorControl() {
      if (regulatorControlBuilder_ == null) {
        return regulatorControl_ == null ? openfmb.regulatormodule.RegulatorControl.getDefaultInstance() : regulatorControl_;
      } else {
        return regulatorControlBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorControl regulatorControl = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setRegulatorControl(openfmb.regulatormodule.RegulatorControl value) {
      if (regulatorControlBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        regulatorControl_ = value;
      } else {
        regulatorControlBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorControl regulatorControl = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setRegulatorControl(
        openfmb.regulatormodule.RegulatorControl.Builder builderForValue) {
      if (regulatorControlBuilder_ == null) {
        regulatorControl_ = builderForValue.build();
      } else {
        regulatorControlBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorControl regulatorControl = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeRegulatorControl(openfmb.regulatormodule.RegulatorControl value) {
      if (regulatorControlBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          regulatorControl_ != null &&
          regulatorControl_ != openfmb.regulatormodule.RegulatorControl.getDefaultInstance()) {
          getRegulatorControlBuilder().mergeFrom(value);
        } else {
          regulatorControl_ = value;
        }
      } else {
        regulatorControlBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorControl regulatorControl = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearRegulatorControl() {
      bitField0_ = (bitField0_ & ~0x00000002);
      regulatorControl_ = null;
      if (regulatorControlBuilder_ != null) {
        regulatorControlBuilder_.dispose();
        regulatorControlBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorControl regulatorControl = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.regulatormodule.RegulatorControl.Builder getRegulatorControlBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getRegulatorControlFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorControl regulatorControl = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.regulatormodule.RegulatorControlOrBuilder getRegulatorControlOrBuilder() {
      if (regulatorControlBuilder_ != null) {
        return regulatorControlBuilder_.getMessageOrBuilder();
      } else {
        return regulatorControl_ == null ?
            openfmb.regulatormodule.RegulatorControl.getDefaultInstance() : regulatorControl_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorControl regulatorControl = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.regulatormodule.RegulatorControl, openfmb.regulatormodule.RegulatorControl.Builder, openfmb.regulatormodule.RegulatorControlOrBuilder> 
        getRegulatorControlFieldBuilder() {
      if (regulatorControlBuilder_ == null) {
        regulatorControlBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.regulatormodule.RegulatorControl, openfmb.regulatormodule.RegulatorControl.Builder, openfmb.regulatormodule.RegulatorControlOrBuilder>(
                getRegulatorControl(),
                getParentForChildren(),
                isClean());
        regulatorControl_ = null;
      }
      return regulatorControlBuilder_;
    }

    private openfmb.regulatormodule.RegulatorSystem regulatorSystem_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.regulatormodule.RegulatorSystem, openfmb.regulatormodule.RegulatorSystem.Builder, openfmb.regulatormodule.RegulatorSystemOrBuilder> regulatorSystemBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorSystem regulatorSystem = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the regulatorSystem field is set.
     */
    public boolean hasRegulatorSystem() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorSystem regulatorSystem = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The regulatorSystem.
     */
    public openfmb.regulatormodule.RegulatorSystem getRegulatorSystem() {
      if (regulatorSystemBuilder_ == null) {
        return regulatorSystem_ == null ? openfmb.regulatormodule.RegulatorSystem.getDefaultInstance() : regulatorSystem_;
      } else {
        return regulatorSystemBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorSystem regulatorSystem = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setRegulatorSystem(openfmb.regulatormodule.RegulatorSystem value) {
      if (regulatorSystemBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        regulatorSystem_ = value;
      } else {
        regulatorSystemBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorSystem regulatorSystem = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setRegulatorSystem(
        openfmb.regulatormodule.RegulatorSystem.Builder builderForValue) {
      if (regulatorSystemBuilder_ == null) {
        regulatorSystem_ = builderForValue.build();
      } else {
        regulatorSystemBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorSystem regulatorSystem = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeRegulatorSystem(openfmb.regulatormodule.RegulatorSystem value) {
      if (regulatorSystemBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          regulatorSystem_ != null &&
          regulatorSystem_ != openfmb.regulatormodule.RegulatorSystem.getDefaultInstance()) {
          getRegulatorSystemBuilder().mergeFrom(value);
        } else {
          regulatorSystem_ = value;
        }
      } else {
        regulatorSystemBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorSystem regulatorSystem = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearRegulatorSystem() {
      bitField0_ = (bitField0_ & ~0x00000004);
      regulatorSystem_ = null;
      if (regulatorSystemBuilder_ != null) {
        regulatorSystemBuilder_.dispose();
        regulatorSystemBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorSystem regulatorSystem = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.regulatormodule.RegulatorSystem.Builder getRegulatorSystemBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getRegulatorSystemFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorSystem regulatorSystem = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.regulatormodule.RegulatorSystemOrBuilder getRegulatorSystemOrBuilder() {
      if (regulatorSystemBuilder_ != null) {
        return regulatorSystemBuilder_.getMessageOrBuilder();
      } else {
        return regulatorSystem_ == null ?
            openfmb.regulatormodule.RegulatorSystem.getDefaultInstance() : regulatorSystem_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.regulatormodule.RegulatorSystem regulatorSystem = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.regulatormodule.RegulatorSystem, openfmb.regulatormodule.RegulatorSystem.Builder, openfmb.regulatormodule.RegulatorSystemOrBuilder> 
        getRegulatorSystemFieldBuilder() {
      if (regulatorSystemBuilder_ == null) {
        regulatorSystemBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.regulatormodule.RegulatorSystem, openfmb.regulatormodule.RegulatorSystem.Builder, openfmb.regulatormodule.RegulatorSystemOrBuilder>(
                getRegulatorSystem(),
                getParentForChildren(),
                isClean());
        regulatorSystem_ = null;
      }
      return regulatorSystemBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:regulatormodule.RegulatorControlProfile)
  }

  // @@protoc_insertion_point(class_scope:regulatormodule.RegulatorControlProfile)
  private static final openfmb.regulatormodule.RegulatorControlProfile DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.regulatormodule.RegulatorControlProfile();
  }

  public static openfmb.regulatormodule.RegulatorControlProfile getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<RegulatorControlProfile>
      PARSER = new com.google.protobuf.AbstractParser<RegulatorControlProfile>() {
    @java.lang.Override
    public RegulatorControlProfile parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<RegulatorControlProfile> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<RegulatorControlProfile> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.regulatormodule.RegulatorControlProfile getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

